QGIS Application - Bug report #18270
QGIS 3.0 import dxf python code issue
2018-02-28 01:01 PM - PJ Lightning

Status: Closed

Priority: High

Assignee:

Category: Python bindings / sipify

Affected QGIS version:3.0.0 Regression?: Yes
Operating System: Win7 Pro Easy fix?: No
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupls data: Copied to github as #: 26161
Description

The code:

import glob, os
path = "E:/aawork/etc/etc/etc/dxfs/"
for layer in glob.glob(path + "*.dxf"):
vlayer = QgsVectorLayer(layer, 'name’, 'ogr')
subLayers = vlayer.dataProvider().subLayers()
for subLayer in subLayers:
geom_type = subLayer.split(":")[-1]
if geom_type == 'Point":
uri = "%s|layername=entities|geometrytype=%s" % (layer, geom_type,)
dfx_file_name = os.path.splitext(os.path.basename(layer))[0]
layer_name = "%s - %s" % (dfx_file_name,geom_type,)
sub_vlayer = QgsVectorLayer(uri, layer_name, 'ogr')
QgsMapLayerRegistry.instance().addMapLayer(sub_vlayer)

In QGIS 2.18, this code imports points from all the dxfs in the folder.

In 3.0 it just triggers a series of boxes to select the CRS but then nothing imports.

History

#1 - 2018-02-28 01:03 PM - Giovanni Manghi
- Category changed from PyQGIS Console to DWG/DXF import
- Status changed from Open to Feedback

Does it work as expected in 2.18?

#2 - 2018-02-28 01:06 PM - PJ Lightning

Giovanni Manghi wrote:

Does it work as expected in 2.187?

Yes. Sorry, it seems that all the code indents vanished when | saved the report.

It works as expected in 2.18. It imports the points (labels on several maps), which | can then easily merge into one shape file.
#3 - 2018-02-28 01:07 PM - Giovanni Manghi
- Regression? changed from No to Yes

- Status changed from Feedback to Open

- Priority changed from Normal to High

#4 - 2018-02-28 08:59 PM - Nyall Dawson

- Status changed from Open to Closed

Check the return value of subLayers(). The format is different and no longer separated by "' characters alone.

#5 - 2018-02-28 10:48 PM - PJ Lightning

- Status changed from Closed to Reopened

Nyall Dawson wrote:

Check the return value of subLayers(). The format is different and no longer separated by ':' characters alone.

Hi, could you repeat that in English, please?

The code was written for me by someone who understands coding. | have no idea what your reply means.

It worked in the last version and does not work now.

#6 - 2018-02-28 11:12 PM - Salvatore Larosa
- Category changed from DWG/DXF import to Python bindings / sipify

and you should to get an error on this line as well: QgsMapLayerRegistry.instance().addMapLayer(sub_vlayer)

#7 - 2018-03-01 10:55 AM - Giovanni Manghi
- Status changed from Reopened to Closed

- Resolution set to invalid

PJ Lightning wrote:

Nyall Dawson wrote:

Check the return value of subLayers(). The format is different and no longer separated by ':' characters alone.

Hi, could you repeat that in English, please?

the code needs to be changed to work in ggis 3.

#8 - 2018-03-01 01:09 PM - PJ Lightning

Giovanni Manghi wrote:
PJ Lightning wrote:
Nyall Dawson wrote:

Check the return value of subLayers(). The format is different and no longer separated by ':' characters alone.

Hi, could you repeat that in English, please?

the code needs to be changed to work in qgis 3.

If this isn't a bug, where is the information that would explain how to alter the code?
3.0 is completely useless if the codes don't work. The download didn't include telepathic powers.

#9 - 2018-03-03 10:57 AM - Giovanni Manghi

If this isn't a bug, where is the information that would explain how to alter the code?

3.0 is completely useless if the codes don't work. The download didn't include telepathic powers.

??? in any software at any new major release changes are expected.
